<?php
if (!defined('IN_AJAX')) die(basename(__FILE__));

global $bb_cfg, $lang;

$mode = (string) $this->request['mode'];
$html = '';

switch ($mode)
{
	case 'last_added':
		if (!$sql = CACHE('bb_cache')->get('last_added'))
		{
			$sql = DB()->fetch_rowset("SELECT
				tr.topic_id, tr.forum_id, tr.reg_time, tr.post_id,
				t.topic_title,
				f.forum_name,
				u.username, u.user_id, u.user_rank
			FROM
				". BB_BT_TORRENTS ." tr
			LEFT JOIN ". BB_TOPICS ." t ON tr.topic_id = t.topic_id
			LEFT JOIN ". BB_FORUMS ." f ON tr.forum_id = f.forum_id
			LEFT JOIN ". BB_USERS ." u  ON tr.poster_id = u.user_id
			LEFT JOIN ". BB_ATTACHMENTS_DESC ." atd ON tr.attach_id = atd.attach_id
			ORDER BY
				tr.reg_time DESC
			LIMIT 0,".$bb_cfg['t_last_added_num']);
			CACHE('bb_cache')->set('last_added', $sql, $bb_cfg['top_cache']*60);
		}

		foreach ($sql as $row)
		{
			$topic_title   = addslashes(str_short($row['topic_title'], $bb_cfg['title_text']));
			$post_id       = $row['post_id'];
			$topic_id      = $row['topic_id'];
			$forum         = $row['forum_name'];
			$forum_id      = $row['forum_id'];
			$torrent_time  = bb_date($row['reg_time'], $bb_cfg['date_format']);
			$autor_post    = profile_url($row);
			$autor_post_id = $row['user_id'];
			$post_time     = bb_date($row['reg_time']);
			$url_new_post  = make_url(POST_URL . $row['post_id'], $row['topic_title'],true);
			$url_forum     = make_url(FORUM_URL . $row['forum_id'], $row['forum_name'],true);

			$html .= '<li>';
			$html .= '<div class="bCenter"><img src="thumb.php?t='.$topic_id.'" style="width: 105px; height: 150px;" alt="" ></div>';
			$html .= '<div><a href="viewtopic.php?t='.$topic_id.'" style="font-size:11px">'.$topic_title.'</a></div>';
			$html .= '<div style="font-size:10px">'.$lang['AUTHOR'].': '.$autor_post.'</div>';
			$html .= '<div style="font-size:10px">'.$lang['DATE'].': '.$torrent_time.'</div>';
			$html .= '<div style="font-size:10px">'.$lang['FORUM'].': <a href="viewforum.php?f='.$forum_id.'">'.$forum.'</a></div>';
			$html .= '</li>';
			$html .= '<h3></h3>';
		}
		$no_matching = '<div class="pairsJustified"><dl class="discussionCount"><dd style="font-size:11px"><b><span class="leechmed">'.$lang['NO_TOP_MATCH'].'</dd></dl></div>';

		$this->response['html'] = ($sql) ? $html : $no_matching;
	break;

	case 'top_downloaded':
		if (!$sql = CACHE('bb_cache')->get('top_downloaded'))
		{
			$sql = DB()->fetch_rowset("SELECT
				tr.topic_id, tr.forum_id, tr.reg_time, tr.complete_count, tr.size, tr.attach_id,
				t.topic_title,
				f.forum_name,
				u.username, u.user_id, u.user_rank
			FROM
				". BB_BT_TORRENTS ." tr
			LEFT JOIN ". BB_TOPICS ." t ON tr.topic_id = t.topic_id
			LEFT JOIN ". BB_FORUMS ." f ON tr.forum_id = f.forum_id
			LEFT JOIN ". BB_USERS ." u  ON tr.poster_id = u.user_id
			WHERE reg_time > ". (TIMENOW - 30*86400) ."
			ORDER BY
				tr.complete_count DESC
			LIMIT 0,".$bb_cfg['t_top_downloaded']);
			CACHE('bb_cache')->set('top_downloaded', $sql, $bb_cfg['top_cache']*60);
		}
		foreach ($sql as $row)
		{
			$title     = wbr(str_short($row['topic_title'], $bb_cfg['title_text']));
			$topic_id  = $row['topic_id'];
			$forum     = $row['forum_name'];
			$forum_id  = $row['forum_id'];
			$poster    = profile_url($row);
			$poster_id = $row['user_id'];
			$completed = $row['complete_count'];
			$size      = humn_size($row['size']);
			$att_id    = $row['attach_id'];

			$html .= '<li>';
			$html .= '<div class="bCenter"><img src="thumb.php?t='.$topic_id.'" style="width: 105px; height: 150px;" alt="" ></div>';
			$html .= '<div><a href="viewtopic.php?t='.$topic_id.'">'.$title.'</a></div>';
			$html .= '<div style="font-size:10px">'.$lang['AUTHOR'].': '.$poster.'</div>';
			$html .= '<div style="font-size:10px">'.$lang['SIZE'].': '.$size.'</div>';
			$html .= '<div style="font-size:11px"><a href="dl.php?id='.$att_id.'"><strong>'.$lang['DOWNLOAD'].':</strong></a>&nbsp;<span style="font-size:10px">('.$lang['COMPLETED'].' уже&nbsp;<b>'.$completed.'</b>)</span></div>';
			$html .= '<div style="font-size:10px">'.$lang['FORUM'].': <a href="viewforum.php?f='.$forum_id.'">'.$forum.'</a></div>';
			$html .= '</li>';
			$html .= '<h3></h3>';
		}
		$no_matching = '<div class="pairsJustified"><dl class="discussionCount"><dd style="font-size:11px"><b><span class="leechmed">'.$lang['NO_TOP_MATCH'].'</dd></dl></div>';

		$this->response['html'] = ($sql) ? $html : $no_matching;
	break;

	case 'top_uploaders':
		if (!$sql = CACHE('bb_cache')->get('top_uploaders'))
		{
			$sql = DB()->fetch_rowset("SELECT t.user_id, u.username, u.user_rank, SUM( t.u_up_total ) sum
			FROM ". BB_BT_USERS ." t
				LEFT JOIN ". BB_USERS ." u ON ( t.user_id = u.user_id )
				WHERE t.user_id NOT IN(". GUEST_UID .")
				GROUP BY t.user_id
				ORDER BY sum DESC
			LIMIT 0 ,".$bb_cfg['t_top_uploaders']);
			CACHE('bb_cache')->set('top_uploaders', $sql, $bb_cfg['top_cache']*60);
		}
		foreach ($sql as $row)
		{
			$user_id  = $row['user_id'];
			$upl_name = profile_url($row);
			$uploaded = (humn_size($row['sum']));

			$html .= '<div class="pairsJustified"><dl class="discussionCount">';
			$html .= '<dt><a href="profile.php?mode=viewprofile&u='.$user_id.'">'.$upl_name.':</a></dt>';
			$html .= '<dd style="font-size:11px"><b><span class="seedmed">'.$uploaded.'</dd>';
			$html .= '</dl></div>';
		}
		$no_matching = '<div class="pairsJustified"><dl class="discussionCount"><dd style="font-size:11px"><b><span class="leechmed">'.$lang['NO_MATCHING'].'</dd></dl></div>';

		$this->response['html'] = ($sql) ? $html : $no_matching;
	break;

	case 'top_downloaders':
		if (!$sql = CACHE('bb_cache')->get('top_downloaders'))
		{
			$sql = DB()->fetch_rowset("SELECT t.user_id, u.username, u.user_rank, SUM( t.u_down_total ) sum
			FROM ". BB_BT_USERS ." t
				LEFT JOIN ". BB_USERS ." u ON ( t.user_id = u.user_id )
				WHERE t.user_id NOT IN(". GUEST_UID .")
				GROUP BY t.user_id
				ORDER BY sum DESC
			LIMIT 0 ,".$bb_cfg['t_top_downloaders']);
			CACHE('bb_cache')->set('top_downloaders', $sql, $bb_cfg['top_cache']*60);
		}

		foreach ($sql as $row)
		{
			$user_id  = $row['user_id'];
			$upl_name = profile_url($row);
			$uploaded = (humn_size($row['sum']));

			$html .= '<div class="pairsJustified"><dl class="discussionCount">';
			$html .= '<dt><a href="profile.php?mode=viewprofile&u='.$user_id.'">'.$upl_name.':</a></dt>';
			$html .= '<dd style="font-size:11px"><b><span class="leechmed">'.$uploaded.'</dd>';
			$html .= '</dl></div>';
		}
		$no_matching = '<div class="pairsJustified"><dl class="discussionCount"><dd style="font-size:11px"><b><span class="leechmed">'.$lang['NO_MATCHING'].'</dd></dl></div>';

		$this->response['html'] = ($sql) ? $html : $no_matching;
	break;
}

$this->response['mode'] = $mode;